/*

 This unit contains two sample objects for stroring in RVF documents,
 in DocProperties collection.

 TSampleDocObject1 contains properties:
 - TPicture* Thumbnail

 TSampleDocObject2 contains properties:
 - String Signature
 - TDateTime Date

 Of course, we could use a single object to store all these properties.
 But we want to show that DocProperties can contain objects of different
 classes.

*/

//---------------------------------------------------------------------------

#pragma hdrstop


//---------------------------------------------------------------------------
#pragma package(smart_init)

#include "SampleDocObjects.h"

//============================ TSampleDocObject1 ===============================

__fastcall void TSampleDocObject1::SetThumbnail(TPicture* Value)
{
  FThumbnail->Assign(Value);
}

__fastcall TSampleDocObject1::TSampleDocObject1(
  System::Classes::TCollection* ACollection) :
	TRVDocObject(ACollection)
{
  FThumbnail = new Vcl::Graphics::TPicture();
}

__fastcall TSampleDocObject1::~TSampleDocObject1(void)
{
	delete FThumbnail;
}


void __fastcall TSampleDocObject1::Assign(Rvitem::TCustomRVItemInfo* Source)
{
  if (Source->InheritsFrom(__classid(TSampleDocObject1)))
  {
	Thumbnail = ((TSampleDocObject1*)Source)->Thumbnail;
  }
  else
	TRVDocObject::Assign(Source);
}
//============================ TSampleDocObject2 ===============================
__fastcall TSampleDocObject2::TSampleDocObject2(
  System::Classes::TCollection* ACollection) :
	TRVDocObject(ACollection)
{

}

void __fastcall TSampleDocObject2::Assign(Rvitem::TCustomRVItemInfo* Source)
{
  if (Source->InheritsFrom(__classid(TSampleDocObject2)))
  {
	Signature = ((TSampleDocObject2*)Source)->Signature;
	Date      = ((TSampleDocObject2*)Source)->Date;
  }
  else
	TRVDocObject::Assign(Source);
}
// ========================== Initialization ===================================
class TSampleObjectInitializer
{
  public:
	TSampleObjectInitializer()
	{
	  RegisterClass(__classid(TSampleDocObject1));
	  RegisterClass(__classid(TSampleDocObject2));
    }
};

static TSampleObjectInitializer Initializer;
